package com.xypower.mpmaster;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.View;


import com.dev.devapi.api.SysApi;
import com.xypower.common.MicroPhotoContext;

import java.text.SimpleDateFormat;
import java.util.Date;


public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        ActionBar actionBar = getSupportActionBar();

        // String buildTime = BuildConfig.BUILD_
        Date date = new Date(BuildConfig.BUILD_TIMESTAMP);
        // SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        actionBar.setTitle(actionBar.getTitle().toString() + " v" + MicroPhotoContext.getVersionName(getApplicationContext()) + " " + sdf.format(date));

        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        findViewById(R.id.btnEnableCam3V3).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                SysApi.setCam3V3Enable(true);
            }
        });

        findViewById(R.id.btnDisableCam3V3).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                SysApi.setCam3V3Enable(false);
            }
        });

        findViewById(R.id.btnTurnOtgOn).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                SysApi.setOtgState(true);
            }
        });

        findViewById(R.id.btnTurnOtgOff).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                SysApi.setOtgState(false);
            }
        });

        startMicroPhotoService(getApplicationContext());
    }

    public static void startMicroPhotoService(Context context) {

        MicroPhotoContext.AppConfig appConfig = MicroPhotoContext.getMpAppConfig(context);

        Intent intent = new Intent(context, MpMasterService.class);
        intent.setAction(MpMasterService.ACTION_START);
        intent.putExtra("cmdid", appConfig.cmdid);
        intent.putExtra("server", appConfig.server);
        intent.putExtra("port", appConfig.port);
        intent.putExtra("protocol", appConfig.protocol);
        intent.putExtra("networkProtocol", appConfig.networkProtocol);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            context.startForegroundService(intent);
        } else {
            context.startService(intent);
        }
    }
}